; ==============================================================================
;   MGSP
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver.	Description
; ==============================================================================
		include	"MSXBIOS.ASM"
		include	"MSXDOS1.ASM"
		include	"MSXDOS2.ASM"
		include	"MGSDRV_API.ASM"

		org		0x100
; ==============================================================================
entry::
		ld			sp, [TPA_BOTTOM]
		call		mgsp_init

; ==============================================================================
; C[v
; ==============================================================================
		scope		mgsp_main_loop
main_loop:
		call		mgsp_common_proc
		call		mgsp_check_key
		jp			main_loop
		endscope

; ==============================================================================
; C[v̒̃L[͈ȊO
; ==============================================================================
		scope		mgsp_common_proc
mgsp_common_proc::
		call		change_mgsdrv_slot
		call		vsync_wait
		call		mgsp_check_song_change
		call		grp_update_keyboard_spot		; A ɉғ̃gbNԂ
		call		mgsp_check_song_stop

		; ȖXN[
		ld			a, [title_scroll_timer]
		dec			a
		ld			[title_scroll_timer], a
		or			a, a
		jp			nz, skip1

		call		update_title
		ld			a, title_scroll_wait
		ld			[title_scroll_timer], a
skip1:
		ret
		endscope

title_scroll_wait := 20

; ==============================================================================
; 1R}҂ (30fps)
; ==============================================================================
		scope		vsync_wait
vsync_wait::
		ld			a, [timer_counter]
		cp			a, 2
		jr			c, vsync_wait
		xor			a, a
		ld			[timer_counter], a
		ret
		endscope

; ==============================================================================
; Wo͂Ƀo[WbZ[W\
; ==============================================================================
		scope		show_version_message
show_version_message::
		ld			de, mgsp_name
		call		puts
		ld			de, msg_ret
		call		puts
		ld			de, mgsp_copyright
		call		puts
		ld			de, msg_ret
		jp			puts
		endscope

; ==============================================================================
; 샂[hύX
; ==============================================================================
		scope		change_mode
change_mode::
		ld			a, [play_mode]
		inc			a
		cp			a, 3
		jr			nz, skip1
		xor			a, a
skip1:
		ld			[play_mode], a
		jp			grp_update_mode_info
		endscope

; ==============================================================================
; ̋ȂĐ
; ==============================================================================
		scope		start_next_song
start_next_song::
		call		clear_mgsdrv_track_work
		; t@CP݂Ȃꍇ͉Ȃ
		ld			a, [fl_files]
		or			a, a
		jp			z, error_start_next_song
		ld			b, a

		; 샂[h𔻕
		ld			a, [play_mode]
		or			a, a
		jp			z, normal_mode
		dec			a
		jp			z, random_mode
repeat_mode:
		ld			a, [playing_song_number]
		jr			check_and_play

random_mode:
		call		get_random			; b ͕ۑ
adjust_random_max:
		cp			a, b
		jr			c, check_and_play
		sub			a, b
		jr			adjust_random_max

normal_mode:
		; Đ̋Ȃ̎̔ԍ𓾂
		ld			a, [playing_song_number]
change_next:
		inc			a
		cp			a, b
		jp			nc, error_start_next_song

check_and_play:
		; fBNg?
		ld			c, a
		call		get_current_file_entry
		ld			de, 13
		add			hl, de
		ld			a, [hl]
		and			a, FIB_ATTR_DIRECTORY
		ld			a, c
		jr			nz, change_next
		call		play_new_song
		ret

error_start_next_song::
		xor			a, a
		ld			[play_state], a
		ld			[playing_song_number], a
		ret
		endscope

; ==============================================================================
; ŐȂĐ
; ==============================================================================
		scope		start_previous_song
start_previous_song::
		call		clear_mgsdrv_track_work
		; t@CP݂Ȃꍇ͉Ȃ
		ld			a, [fl_files]
		or			a, a
		jp			z, error_start_previous_song
		ld			b, a

		; 샂[h𔻕
		ld			a, [play_mode]
		or			a, a
		jp			z, normal_mode
		dec			a
		jp			z, random_mode
repeat_mode:
		ld			a, [playing_song_number]
		jr			check_and_play

random_mode:
		call		get_random			; b ͕ۑ
adjust_random_max:
		cp			a, b
		jr			c, check_and_play
		sub			a, b
		jr			adjust_random_max

normal_mode:
		; Đ̋Ȃ̑O̔ԍ𓾂
		ld			a, [playing_song_number]
change_previous:
		sub			a, 1
		jp			c, error_start_previous_song

check_and_play:
		; fBNg?
		ld			c, a
		call		get_current_file_entry
		ld			de, 13
		add			hl, de
		ld			a, [hl]
		and			a, FIB_ATTR_DIRECTORY
		ld			a, c
		jr			nz, change_previous
		call		play_new_song
		ret

error_start_previous_song::
		xor			a, a
		ld			[play_state], a
		ld			[playing_song_number], a
		ret
		endscope

; ==============================================================================
; 
; ==============================================================================
		scope		mgsp_init
mgsp_init::
		; Key Click Sound S/W OFF
		ld			a, [cliksw]
		ld			[cliksw_backup], a

		; Show version information
		call		show_version_message

		; Initialize MemoryMapper
		call		mmap_init
		ld			de, msg_error_mmap_not_found
		jp			z, g_error_exit

		; check installed MGSDRV
		call		init_mgsdrv
		ld			de, msg_error_mgsdrv_not_found
		jp			nz, g_error_exit

		; show MGSDRV version
		call		change_mgsdrv_slot
		ld			de, msg_detect
		call		puts

		ld			a, [mgs_id_mgsver + 1]
		ld			hl, msg_1byte_hex
		call		dec_to_hex

		ld			de, msg_1byte_hex + 1
		call		puts

		ld			c, D1F_CONOUT
		ld			e, '.'
		call		bdos

		ld			a, [mgs_id_mgsver]
		ld			hl, msg_1byte_hex
		call		dec_to_hex

		ld			de, msg_1byte_hex
		call		puts

		ld			de, msg_ret
		call		puts

		; show OPLL slot number
		ld			de, msg_opll_slot_num
		call		puts
		ld			ix, [mgs_id_mibadr]
		ld			a, [ix + 0]
		call		put_slot_num
		ld			de, msg_ret
		call		puts

		; show SCC slot number
		ld			de, msg_scc_slot_num
		call		puts
		ld			ix, [mgs_id_mibadr]
		ld			a, [ix + 1]
		call		put_slot_num
		ld			de, msg_ret
		call		puts

		; check command line options
		call		check_options

		;  GUINm

		; initialize kanji driver
		call		kanji_init
		or			a, a
		jr			z, kanji_init_no_error

		ld			de, msg_not_enough_memory
		dec			a
		jp			z, g_error_exit

		ld			de, msg_cannot_read_kfont
		jp			g_error_exit
kanji_init_no_error:

		call		load_ini_file

		; MSX1 ̏ꍇAINIt@C LOAD_TIME ͖ɂ
		ld			a, [exptbl]
		ld			hl, 0x002D					; MSX1=0, MSX2=1, MSX2+=2, MSXtR=3
		call		rdslt

		or			a, a
		jr			nz, skip_disable_load_time
		ld			[show_cpu_load_time], a		; MSX1 ł͖ɂ
skip_disable_load_time:

		; L[NbN OFF
		xor			a, a
		ld			[cliksw], a

		call		change_mgsdrv_slot
		call		clear_mgsdrv_track_work
		call		file_init
		call		grp_theme_color_change
		call		grp_init
		ld			a, [master_volume]
		call		grp_update_master_volume
		ld			a, [loop_counter]
		call		grp_update_loop_count
		ld			a, [sort_mode]
		call		grp_update_sort_mode_info
		ld			a, [play_mode]
		call		grp_update_mode_info
		call		change_mgsdrv_slot

		xor			a, a
		ld			[mgs_song_title], a

		call		fl_update_entries
		ld			a, 1
		call		grp_update_file_list
		call		init_function_keys
		ret
		endscope

; ==============================================================================
; L[͂Ƃɉ
; ==============================================================================
		scope		mgsp_check_key
mgsp_check_key::
		; L[obt@`FbN
		ld			ix, CHSNS
		ld			iy, [exptbl - 1]
		call		CALSLT
		jp			z, skip_key_input

		; L[͂ɂď
		ld			ix, CHGET
		call		CALSLT
		call		toupper
		ld			hl, keymap_table
		call		call_keymap
skip_key_input:

		; WCXeBbN͂ɂď
		ld			a, 1				; Joypad1 A button
		ld			ix, GTTRIG
		ld			iy, [exptbl - 1]
		call		CALSLT
		and			a, JOYMAP_A
		push		af

		ld			a, 3				; Joypad1 B button
		ld			ix, GTTRIG
		ld			iy, [exptbl - 1]
		call		CALSLT
		and			a, JOYMAP_B
		pop			bc
		or			a, b
		push		af

		ld			a, 1				; Joypad1 stick
		ld			ix, GTSTCK
		ld			iy, [exptbl - 1]
		call		CALSLT
		pop			bc
		or			a, b

		ld			b, a
		ld			a, [joy_last_stick]
		cp			a, b					; O̓͂ƓH
		ld			a, b
		ld			[joy_last_stick], a
		ld			a, 30					; ͂ wait  30/60[sec]
		jr			nz, joy_key_affect

		ld			a, [joy_key_wait]		; OƓ͓ŁA wait  0H
		dec			a
		ld			[joy_key_wait], a
		jr			nz, skip_joy_key
		ld			a, 4					; s[gԊu wait  4/60[sec]
joy_key_affect:
		ld			[joy_key_wait], a
		ld			a, b
		ld			hl, joymap_table
		call		call_keymap
skip_joy_key:

		ret
		endscope

; ==============================================================================
; AWX^ƃL[}bve[uɏ]ăTu[`R[
; input)
;	A .... L[R[h
;	HL ... L[}bve[ũAhX
; break)
;	all
; ==============================================================================
		scope		call_keymap
call_keymap::
		ld			de, 3
keymap_loop:
		ld			b, [hl]
		inc			b
		ret			z						; terminator Ȃ甲
		dec			b
		cp			a, b
		jp			z, call_keymap_routine
		add			hl, de
		jp			keymap_loop
call_keymap_routine:
		inc			hl
		ld			e, [hl]
		inc			hl
		ld			d, [hl]
		ex			de, hl
		jp			hl
		endscope

; ==============================================================================
; tԊĎ
; ==============================================================================
		scope		mgsp_check_song_change
mgsp_check_song_change::
		; tI`FbN
		ld			a, [play_state]				; A = 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
		or			a, a
		jp			z, preload_song_title		; ~ȂȖv[h
		dec			a
		jp			z, play_next_song			; ̋ȍĐ҂Ȃ玟̋ȂĐ
		dec			a
		jp			z, wait_fadeout				; tF[hAEgȂtF[hAEg`FbN
		; t񐔂 loop_counter ɒB?
		ld			a, [play_mode]
		cp			a, 2						; repeat mode ȂAloop񐔃`FbN͂Ȃ
		ret			z
		ld			hl, [mgs_id_mibadr]
		ld			de, mgs_mib_loopct
		add			hl, de
		ld			a, [hl]
		ld			hl, loop_counter
		cp			a, [hl]
		ret			c							; BĂȂȂ牽Ȃ
		call		start_fadeout
		ret
		; tF[hAEg
wait_fadeout:
		ld			a, [fadeout_volume]
		ld			b, a
		ld			a, [fadeout_speed]
		add			a, b
		ld			[fadeout_volume], a
		jp			c, fadeout_end
		srl			a
		srl			a
		srl			a
		srl			a
		call		mgs_msvst
		ei
		ret
fadeout_end:
		; ̋Ȃ̍Đ҂֑J
		call		mgsp_stop_song
		ld			a, 1
		ld			[play_state], a
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret

play_next_song:
		; ̋ȂĐ
		ld			a, [error_status]
		or			a, a
		ret			nz
		call		preload_song_title			; łɃv[h
		call		preload_song_title			; łɃv[h
		call		start_next_song
		ret
		endscope

; ==============================================================================
; hCuύX
; ==============================================================================
		scope		mgsp_drive_change
mgsp_drive_change::
		sub			a, '1'				; '1' = AhCu, '2'=BhCu ... '8'=HhCu

		push		af
		call		mgsp_stop_song		; t̋Ȃ~
		pop			af

		call		change_current_drive
		push		af

		xor			a, a
		ld			[play_state], a		; ~ԂɕύX

		call		grp_update_current_drive
		call		grp_update_error_indicator
		pop			af
		ret			z

		call		grp_unselect_playing_line
		call		mgsp_update_file_list_all
		ret
		endscope

; ==============================================================================
; I_CAO\
; ==============================================================================
		scope		mgsp_show_exit_dialog
mgsp_show_exit_dialog::
		call		grp_unselect_playing_line
		call		grp_unselect_line
		call		grp_show_exit_dialog

		; XN[o[uXN[Ȃv\ɂ
		ld			a, [fl_files]
		ld			[fl_files_restore], a
		xor			a, a
		ld			[fl_files], a
		call		grp_update_scroll_bar

		; A{^҂
		call		wait_release_joy_a

main_loop:
		call		mgsp_common_proc

		; L[obt@`FbN
		ld			ix, CHSNS
		ld			iy, [exptbl - 1]
		call		CALSLT
		jp			z, skip_key_input

		; L[͂Βʏɖ߂
		ld			ix, CHGET
		call		CALSLT

		; L[Ȃ exit_exit_dialog 
		cp			a, ' '
		jp			z, exit_exit_dialog
		cp			a, 0x0D
		jp			z, exit_exit_dialog

		; ȊOȂIύX
		ld			a, [grp_yes_no]
		xor			a, 1
		ld			[grp_yes_no], a
		call		grp_update_exit_dialog_cursor

skip_key_input:
		ld			a, 1
		ld			ix, GTTRIG
		ld			iy, [exptbl - 1]
		call		CALSLT
		inc			a
		jp			z, exit_exit_dialog

		ld			a, 1					; Joypad1 stick
		ld			ix, GTSTCK
		call		CALSLT

		ld			b, a
		ld			a, [joy_last_stick]
		cp			a, b					; O̓͂ƓH
		jp			z, skip_joy_input

		ld			[joy_last_stick], a
		ld			a, [grp_yes_no]
		xor			a, 1
		ld			[grp_yes_no], a
skip_joy_input:
		jp			main_loop

exit_exit_dialog:
		ld			a, [grp_yes_no]
		or			a, a
		jp			z, exit_main_loop			; YES ȂI

return_mgsp:
		ld			a, 3
		call		grp_clear_line
		ld			a, 4
		call		grp_clear_line
		ld			a, 5
		call		grp_clear_line
		ld			a, 6
		call		grp_clear_line

		call		wait_release_joy_a

fl_files_restore	= $ + 1
		ld			a, 0						; ȏ fl_files ̓K؂Ȓl
		ld			[fl_files], a

		ld			a, 1
		ld			[grp_select_line_on], a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret

wait_release_joy_a:
		call		mgsp_common_proc
		ld			a, 1
		ld			ix, GTTRIG
		ld			iy, [exptbl - 1]
		call		CALSLT
		inc			a
		jp			z, wait_release_joy_a
		ret
		endscope

; ==============================================================================
; wv\
; ==============================================================================
		scope		mgsp_show_help
mgsp_show_help::
		call		grp_unselect_playing_line
		call		grp_unselect_line
		call		grp_show_help

		; XN[o[uXN[Ȃv\ɂ
		ld			a, [fl_files]
		ld			[fl_files_restore], a
		xor			a, a
		ld			[fl_files], a
		call		grp_update_scroll_bar

main_loop:
		call		mgsp_common_proc

		; L[obt@`FbN
		ld			ix, CHSNS
		ld			iy, [exptbl - 1]
		call		CALSLT
		jp			z, skip_key_input

		; L[͂Βʏɖ߂
		ld			ix, CHGET
		call		CALSLT
		jp			exit_help
skip_key_input:

		ld			a, 1
		ld			ix, GTTRIG
		ld			iy, [exptbl - 1]
		call		CALSLT
		inc			a
		jp			z, exit_help
		jp			main_loop

exit_help:
fl_files_restore	= $ + 1
		ld			a, 0						; ȏ fl_files ̓K؂Ȓl
		ld			[fl_files], a

		ld			a, 1
		ld			[grp_select_line_on], a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; ĐJn
; ==============================================================================
		scope		mgsp_play_song
mgsp_play_song::
		ld			a, [master_volume]
		call		mgs_msvst
		ei

		ld			a, 0xFF
		ld			h, a
		ld			l, a
		ld			[track_mute], hl
		ld			[track_mute + 2], a

		call		play_song
		ret
		endscope

; ==============================================================================
; Đ~
; ==============================================================================
		scope		mgsp_stop_song
mgsp_stop_song::
		call		clear_mgsdrv_track_work
		call		grp_unselect_playing_line
		xor			a, a
		ld			[fadeout_volume], a
		ld			[play_state], a
		dec			a
		ld			[grp_play_file], a
		call		grp_playing_line
		call		grp_select_line
		ret
		endscope

; ==============================================================================
; Ȃ̍Đ~`FbN
; input)
;	A .... Number of active tracks
; ==============================================================================
		scope		mgsp_check_song_stop
mgsp_check_song_stop::
		or			a, a
		ret			nz					; Đ̃gbNcĂ̂ŉȂ

		ld			a, [play_state]
		or			a, a
		ret			z					; ĐĂȂԂȂ̂ŉȂ

		; ̋ȂĐԂɑJڂ
		ld			a, 1
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; 𓾂
; ==============================================================================
		scope		get_random
get_random::
		ld			a, [random_seed1]
		rlca
		xor			a, 0x24
		ld			[random_seed1], a
		ld			d, a
		ld			a, [random_seed2]
		rrca
		xor			a, 0x41
		ld			[random_seed2], a
		xor			a, d
		add			a, 0x73
		ret
		endscope

; ==============================================================================
; fBNgGgŃ\[g
; ==============================================================================
		scope		sort_by_entry
sort_by_entry::
		call		fl_sort_normal

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		xor			a, a
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; ȖŃ\[g
; ==============================================================================
		scope		sort_by_title
sort_by_title::
		call		fl_sort_title

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		ld			a, 1
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; t@CŃ\[g
; ==============================================================================
		scope		sort_by_filename
sort_by_filename::
		call		fl_sort_filename

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		ld			a, 2
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; Vbt
; ==============================================================================
		scope		sort_by_shuffle
sort_by_shuffle::
		call		fl_sort_shuffle

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot

		ld			a, 3
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; Ȗ\Et@C\̐؂ւ
; ==============================================================================
		scope		toggle_file_list_mode
toggle_file_list_mode::
		ld			a, [grp_file_list_mode]
		xor			a, 1
		ld			[grp_file_list_mode], a

		ld			a, 1
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; tF[hAEgJn
; ==============================================================================
		scope		start_fadeout
start_fadeout::
		ld			a, [play_state]
		cp			a, 3
		ret			nz
		ld			a, [master_volume]
		add			a, a
		add			a, a
		add			a, a
		add			a, a
		ld			[fadeout_volume], a
		ld			a, 2
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		up_select
up_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		down_select
down_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		inc			a
		cp			a, b
		ret			nc						; łɈԉȂ牽Ȃ
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[WAbv
; ==============================================================================
		scope		left_select
left_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		sub			a, 9
		jr			nc, left_select_clip
		xor			a, a
left_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[W_E
; ==============================================================================
		scope		right_select
right_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		add			a, 9
		cp			a, b
		jr			c, right_select_clip
		ld			a, b
		dec			a
right_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[Wgbv
; ==============================================================================
		scope		minus_select
minus_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		xor			a, a
		ld			[grp_select_file], a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; y[W{g
; ==============================================================================
		scope		plus_select
plus_select::
		ld			a, [fl_files]
		ld			b, a
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		ld			a, b
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		call		grp_update_file_list
		call		change_mgsdrv_slot
		ret
		endscope

; ==============================================================================
; I
; ==============================================================================
		scope		exit_main_loop
exit_main_loop::
		ei
		call		mgsp_stop_song
		call		term_mgsdrv
		call		grp_term
		call		file_term
exit_command_line::
		call		mmap_change_to_tpa

		ld			ix, inifnk
		ld			iy, [exptbl - 1]
		call		CALSLT

		; L[NbNXCb`𕜌
		ld			a, [cliksw_backup]
		ld			[cliksw], a

		ld			b, 0
		ld			c, D2F_TERM
		jp			bdos
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_down
loop_down::
		ld			a, [loop_counter]
		dec			a
		ret			z						; ł 1 Ȃ牽Ȃ
		ld			[loop_counter], a
		call		grp_update_loop_count
		jp			change_mgsdrv_slot
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_up
loop_up::
		ld			a, [loop_counter]
		inc			a
		cp			a, 65
		ret			z						; ł 64 Ȃ牽Ȃ
		ld			[loop_counter], a
		call		grp_update_loop_count
		jp			change_mgsdrv_slot
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_up
master_volume_up::
		ld			a, [master_volume]
		dec			a
		ret			m
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_down
master_volume_down::
		ld			a, [master_volume]
		inc			a
		cp			a, 16
		ret			nc
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	ĐxύX (-10%)
; ==============================================================================
		scope		mgsp_speed_down10
mgsp_speed_down10::
		ld			a, [song_speed]
		sub			a, 10
		cp			a, 20
		jp			nc, skip1
		ld			a, 20
skip1:
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	ĐxύX (-1%)
; ==============================================================================
		scope		mgsp_speed_down1
mgsp_speed_down1::
		ld			a, [song_speed]
		dec			a
		cp			a, 20
		jp			nc, skip1
		ld			a, 20
skip1:
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	ĐxύX (-1%)
; ==============================================================================
		scope		mgsp_speed_reset
mgsp_speed_reset::
		ld			a, 100
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	ĐxύX (+1%)
; ==============================================================================
		scope		mgsp_speed_up1
mgsp_speed_up1::
		ld			a, [song_speed]
		inc			a
		cp			a, 200
		jp			c, skip1
		ld			a, 200
skip1:
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	ĐxύX (+10%)
; ==============================================================================
		scope		mgsp_speed_up10
mgsp_speed_up10::
		ld			a, [song_speed]
		add			a, 10
		cp			a, 200
		jp			c, skip1
		ld			a, 200
skip1:
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	gbN~[g
; ==============================================================================
		scope		mgsp_track_mute1
mgsp_track_mute1::
		add			a, -'!'
		ld			b, a
		ld			a, 1
		jr			z, skip1
loop1:
		rlca
		djnz		loop1
skip1:
		ld			hl, [track_mute]
		xor			a, l
		ld			l, a
		ld			[track_mute], hl
		ld			a, [track_mute + 2]
		ld			b, a
		ld			c, 2
		jp			mgs_tmst1
		endscope

; ==============================================================================
;	t@NVL[
; ==============================================================================
		scope		init_function_keys
init_function_keys::
		ld			hl, ' '
		ld			[fnkstr + 16 * 0], hl
		ld			hl, 'S'
		ld			[fnkstr + 16 * 1], hl
		ld			hl, 'F'
		ld			[fnkstr + 16 * 2], hl
		ld			hl, 0x08		; [BS]
		ld			[fnkstr + 16 * 3], hl
		ld			hl, 'H'
		ld			[fnkstr + 16 * 4], hl
		ld			hl, 'P'
		ld			[fnkstr + 16 * 5], hl
		ld			hl, 0x12		; [INS]
		ld			[fnkstr + 16 * 6], hl
		ld			hl, 0x7F		; [DEL]
		ld			[fnkstr + 16 * 7], hl
		ld			hl, 0x0B		; [HOME]
		ld			[fnkstr + 16 * 8], hl
		ld			hl, 0x1B		; [ESC]
		ld			[fnkstr + 16 * 9], hl
		ret
		endscope

; ==============================================================================
;	G[I
; ==============================================================================
		scope		g_error_exit
g_error_exit::
		ei
		push		de
		call		mmap_change_to_tpa
		pop			de

		call		puts

		ld			b, 1
		ld			c, D2F_TERM
		jp			bdos
		endscope

; ==============================================================================
; efBNgֈړ
; ==============================================================================
		scope		goto_parent_dir
goto_parent_dir::
		ld			ix, parent_dir
		jp			enter_directory
parent_dir:
		ds			".."
		db			0
		endscope

; ==============================================================================
;	I𒆂̋ȃf[^Đ
; ==============================================================================
		scope		play_current_song
play_current_song::
		ld			a, [grp_select_file]
play_new_song::
		push		af
		call		grp_unselect_playing_line
		pop			af
		ld			c, a
		ld			[grp_play_file], a
		call		get_current_file_entry
		ret			z							; t@C
		push		hl
		pop			ix
		ld			a, [ix + 13]
		and			a, FIB_ATTR_DIRECTORY
		jp			nz, enter_directory

		ld			a, c
		ld			[playing_song_number], a

		ex			de, hl
		push		de
		call		change_mgsdrv_slot
		pop			de
		call		load_mgs_file_and_show_title
		ret			z
		call		mgsp_play_song
		; tԂɕύX
		ld			a, 3
		ld			[play_state], a
		xor			a, a
		call		grp_update_file_list
		ret

enter_directory::
		push		ix
		call		mgsp_stop_song
		xor			a, a
		ld			[play_state], a
		pop			de
		call		change_directory

mgsp_update_file_list_all::
		; t@CXgXV
		call		fl_update_entries

		; J[\ԏɕύX
		xor			a, a
		ld			[grp_select_file], a
		ld			[playing_song_number], a
		; Đ̋\͔\ɕύX
		dec			a
		ld			[grp_play_file], a

		; \XV
		dec			a
		ld			[grp_top_file], a
		xor			a, a
		call		grp_update_file_list
		ret
		endscope

; ==============================================================================
;	R}hCIvV𒲂ׂ
;	input)
;		[dma] .... Command line parameter
; ==============================================================================
		scope		check_options
check_options::
		ld			hl, dma + 1
		ld			b, 127				; max length of dma
skip_white_space:
		call		get_upper_one
		ret			z
		cp			a, ' '
		jr			z, skip_white_space

		cp			a, '/'				; this is a option?
		jp			z, skip_white_space

		cp			a, 'P'
		jr			nz, skip_white_space
		ld			a, 1
		ld			[option_p], a
		jp			skip_white_space
		endscope

		scope		get_one
get_one::
		ld			a, b
		or			a, a
		ret			z
		ld			a, [hl]
		inc			hl
		dec			b
		or			a, a
		ret
		endscope

		scope		get_upper_one
get_upper_one::
		call		get_one
		ret			z
		cp			a, 'a'
		ret			c
		cp			a, 'z' + 1
		ret			nc
		add			a, 'A' - 'a'
		ret
		endscope

; ==============================================================================
;	t@CǂݍŃ^Cg\XV
;	input)
;		de .... t@C̃AhX (ASCIIZ)
;	output)
;		Zf .... 0: , 1: s
; ==============================================================================
		scope		load_mgs_file_and_show_title
load_mgs_file_and_show_title::
		call		load_mgs_file
		push		af
		call		grp_update_error_indicator
		pop			af
		ret			z

		; clear song Title area
		ld			hl, (256 + 32) * 8
		ld			bc, 32 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT

		; draw song Title
		call		change_mgsdrv_slot
		ld			hl, mgs_song_title
		ld			de, target_file_name
		ld			bc, target_file_name_end - target_file_name
		ldir									; page2 ɂȃf[^̃^Cg page0 ɃRs[

		xor			a, a
		ld			[target_file_name_position], a
		call		update_title

		; copy file name
		ld			hl, [file_name_address]
		ld			de, file_name_copy
		call		copy_file_name

		; clear file name area
		ld			hl, 251 * 8
		ld			bc, 4 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT

		; draw file name
		ld			hl, 251 * 8
		ld			de, file_name_copy
		call		draw_string

		call		change_mgsdrv_slot
		xor			a, a
		inc			a					; Zf = 0:
		ret
		endscope

; ==============================================================================
;	^Cg\XV
;	input)
;		--
;	output)
;		--
; ==============================================================================
		scope		update_title
update_title::
		ld			a, [target_file_name_position]
		ld			e, a
		ld			d, 0
		ld			hl, target_file_name
		add			hl, de
		ex			de, hl
		ld			hl, (256 + 32) * 8
		push		de
		call		draw_string					; page2 RAMƂėp
		pop			de

		or			a, a
		jp			z, skip1

		ld			a, [de]
		call		issjis1st
		ld			a, [target_file_name_position]
		jr			nc, skip2
		inc			a
skip2:
		inc			a
skip1:
		ld			[target_file_name_position], a
		ret
		endscope

; ==============================================================================
;	(HL)AɓĂl16i_v
; ==============================================================================
		scope		dec_to_hex
dec_to_hex::
		ld			b, a
		rrca
		rrca
		rrca
		rrca
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip1
		add			a, 'A' - '0' - 10
skip1:
		ld			[hl], a
		inc			hl
		ld			a, b
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip2
		add			a, 'A' - '0' - 10
skip2:
		ld			[hl], a
		inc			hl
		ret
		endscope

; ==============================================================================
;	AɓĂXbgԍ\
; ==============================================================================
		scope		put_slot_num
put_slot_num::
		ld			[save_slot], a
		inc			a
		jr			z, put_none
		dec			a
		and			a, 3
		add			a, '0'
		ld			e, a
		ld			c, D1F_CONOUT
		call		bdos
		ld			a, [save_slot]
		or			a, a
		ret			p

		ld			e, '-'
		ld			c, D1F_CONOUT
		call		bdos

		ld			a, [save_slot]
		rrca
		rrca
		and			a, 3
		add			a, '0'
		ld			e, a
		ld			c, D1F_CONOUT
		call		bdos
		ret
put_none:
		ld			de, msg_none
		call		puts
		ret

save_slot:
		db			0
		endscope

; ==============================================================================
;	DATA AREA
; ==============================================================================
cliksw_backup::
		db			0
track_mute::
		db			0xFF, 0xFF, 0xFF			; L, H, B : BHLŉʂ 17bit LB1=ON, 0=MUTE
timer_counter::
		db			0
title_scroll_timer::
		db			title_scroll_wait

keymap	macro		keycode, routine_name
		db			keycode
		dw			routine_name
		endm

keymap_table::
		keymap		0x08, goto_parent_dir		; [BS] Key
		keymap		0x0B, change_mode			; [HOME] Key
		keymap		0x0D, play_current_song		; [RETURN] Key
		keymap		0x1B, mgsp_show_exit_dialog	; [ESC] Key
		keymap		0x12, master_volume_down	; [INS] Key
		keymap		0x1C, right_select			; [] Key
		keymap		0x1D, left_select			; [] Key
		keymap		0x1E, up_select				; [] Key
		keymap		0x1F, down_select			; [] Key
		keymap		0x20, play_current_song		; [Space] Key
		keymap		'+', plus_select			; [+] Key
		keymap		'-', minus_select			; [-] Key
		keymap		'D', toggle_file_list_mode	; [D] Key
		keymap		'E', sort_by_filename		; [E] Key
		keymap		'F', start_fadeout			; [F] Key
		keymap		'H', mgsp_show_help			; [H] Key
		keymap		'N', sort_by_entry			; [N] Key
		keymap		'P', mgsp_play_song			; [P] Key
		keymap		'Q', start_previous_song	; [Q] Key
		keymap		'S', mgsp_stop_song			; [S] Key
		keymap		'T', sort_by_title			; [T] Key
		keymap		'W', start_next_song		; [W] Key
		keymap		'X', loop_up				; [X] Key
		keymap		'Y', sort_by_shuffle		; [Y] Key
		keymap		'Z', loop_down				; [Z] Key
		keymap		'1', mgsp_drive_change		; [1] Key
		keymap		'2', mgsp_drive_change		; [2] Key
		keymap		'3', mgsp_drive_change		; [3] Key
		keymap		'4', mgsp_drive_change		; [4] Key
		keymap		'5', mgsp_drive_change		; [5] Key
		keymap		'6', mgsp_drive_change		; [6] Key
		keymap		'7', mgsp_drive_change		; [7] Key
		keymap		'8', mgsp_drive_change		; [8] Key
		keymap		'K', mgsp_speed_down10		; [K] Key
		keymap		'L', mgsp_speed_down1		; [L] Key
		keymap		';', mgsp_speed_reset		; [;] Key
		keymap		':', mgsp_speed_up1			; [:] Key
		keymap		']', mgsp_speed_up10		; []] Key
		keymap		'!', mgsp_track_mute1		; [!] Key
		keymap		'"', mgsp_track_mute1		; ["] Key
		keymap		'#', mgsp_track_mute1		; [#] Key
		keymap		'$', mgsp_track_mute1		; [$] Key
		keymap		'%', mgsp_track_mute1		; [%] Key
		keymap		'&', mgsp_track_mute1		; [&] Key
		keymap		'\'', mgsp_track_mute1		; ['] Key
		keymap		'(', mgsp_track_mute1		; [(] Key
		keymap		0x7F, master_volume_up		; [DEL] Key
		keymap		0xFF, 0x0000				; Terminator

JOYMAP_UP		:= 1		; JOYMAP_UP, DOWN, RIGHT, LEFT ͔r
JOYMAP_RIGHT	:= 3
JOYMAP_DOWN		:= 5
JOYMAP_LEFT		:= 7
JOYMAP_A		:= 16
JOYMAP_B		:= 32
JOYMAP_AB		:= JOYMAP_A + JOYMAP_B

joymap_table::
		keymap		JOYMAP_UP						, up_select				; [] Key
		keymap		JOYMAP_DOWN						, down_select			; [] Key
		keymap		JOYMAP_LEFT						, goto_parent_dir		; [] Key
		keymap		JOYMAP_RIGHT					, play_current_song	; [] Key
		keymap		JOYMAP_A  + JOYMAP_UP			, left_select			; (A) + [] Key
		keymap		JOYMAP_A  + JOYMAP_DOWN			, right_select			; (A) + [] Key
		keymap		JOYMAP_A  + JOYMAP_LEFT			, master_volume_down	; (A) + [] Key
		keymap		JOYMAP_A  + JOYMAP_RIGHT		, master_volume_up		; (A) + [] Key
		keymap		JOYMAP_B  + JOYMAP_UP			, loop_up				; (B) + [] Key
		keymap		JOYMAP_B  + JOYMAP_DOWN			, loop_down				; (B) + [] Key
		keymap		JOYMAP_B  + JOYMAP_LEFT			, mgsp_stop_song		; (B) + [] Key
		keymap		JOYMAP_B  + JOYMAP_RIGHT		, mgsp_play_song		; (B) + [] Key
		keymap		JOYMAP_AB + JOYMAP_UP			, mgsp_show_exit_dialog	; (A) + (B) + [] Key
		keymap		JOYMAP_AB + JOYMAP_DOWN			, start_fadeout			; (A) + (B) + [] Key
		keymap		JOYMAP_AB + JOYMAP_LEFT			, sort_by_entry			; (A) + (B) + [] Key
		keymap		JOYMAP_AB + JOYMAP_RIGHT		, sort_by_title			; (A) + (B) + [] Key
		keymap		0xFF, 0x0000											; Terminator

random_seed1::
		db			0xa3
random_seed2::
		db			0x5b
sort_mode::
		db			0			; \[g[h 0: Entry, 1: Title, 2: File name, 3: Shuffle
play_mode::
		db			0			; 샂[h 0: Normal, 1: Random, 2: Repeat
playing_song_number::
		db			0			; Đ̋Ȃ̃t@Cԍ
play_state::
		db			0			; 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
fadeout_volume::
		db			0
fadeout_speed::
		db			1			; 1: slow speed ... 128: high speed
loop_counter::
		db			1
joy_key_wait::
		db			0
joy_last_stick::
		db			255
master_volume::
		db			0			; 0: Max, 15: Min
target_file_name_position::
		db			0
target_file_name::
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		db			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
target_file_name_end::
		db			0, 0

option_p:
		db			0

msg_error_mmap_not_found::
		ds			"Memory mapper is not found."
		db			0x0d, 0x0a, 0
msg_error_mgsdrv_not_found::
		ds			"Cannot read MGSDRV.COM."
msg_ret::
		db			0x0d, 0x0a, 0
msg_segment_error:
		ds			"Segment error."
		db			0x0d, 0x0a, 0
msg_cannot_read_kfont::
		ds			"Cannot read KFONT.BIN."
		db			0x0d, 0x0a, 0
msg_detect::
		ds			"Detect MGSDRV "
		db			0
msg_opll_slot_num::
		ds			"  OPLL SLOT #"
		db			0
msg_scc_slot_num::
		ds			"  SCC  SLOT #"
		db			0
msg_none::
		ds			"none"
		db			0
msg_1byte_hex::
		ds			"00"
		db			0
msg_cannot_open_file::
		ds			"Cannot open the file."
		db			0x0d, 0x0a, 0
msg_invalid_data::
		ds			"Invalid song data."
		db			0x0d, 0x0a, 0
msg_not_enough_memory::
		ds			"Not enough memory."
		db			0x0d, 0x0a, 0

		include	"MGSDRVCTL.ASM";
		include	"FILE_ACCESS.ASM"
		include	"STRING.ASM"
		include	"STDIO.ASM"
		include	"MEMMAPPER.ASM"
		include	"KANJI.ASM"
		include	"GRAPHIC.ASM"
		include	"GRAPHIC_DATA.ASM"
		include	"GRAPHIC_INIT_DATA.ASM"
		include	"INIFILE.ASM"
end_of_program::
